<?php

require __DIR__.'/bootstrap.php';

try {
    EnviarProduto();
} catch (\Exception $e) {
    return $e->getMessage();
}

function EnviarProduto(){
    try{
        global $instanceManager;
        $rulesClass = $instanceManager->getService('\Controller\ErpController');
        
        $returnProc = $rulesClass->callProcedureEXPORTA_PRODUTO_XML();
        
        $produtos = $rulesClass->retornaProduto();
        
        if ($produtos){
            array_map('enviaProdutoSystax', $produtos);
        }
        
    }
    catch(SoapFault $e){
        $geraLog = $rulesClass->insere_log_prod_xml($envioProduto->return->produto->cProd, $e->getMessage(), 0, 0);
        echo $e->getMessage();
    }
    catch(\Exception $e) {
        echo $e->getMessage();
    }
        
}

function enviaProdutoSystax($produto) {
    $arqXml = str_replace("EXTIPI", "EX_TIPI", $produto["ARQ_XML"]);
    $envioProduto = callWebServiceIncluirProduto($arqXml);
    
    global $instanceManager;
    $rulesClass = $instanceManager->getService('\Controller\ErpController');

    $envioProduto = $rulesClass->UpdateEnviaProdXml($produto['CDPRODUTOINI'], $produto['CDPRODUTOFIN']);
    foreach ($envioProduto->return->produto as $e){
       $arvprod = $e->cProd;
       $message = $e->mensagem;
       $id      = $e->ID;
       $codigo  = $e->codigo;
       
       if($message == "Atualizado com sucesso." || $message == "Inserido com sucesso."){
           $rulesClass->UpdateProduto($arvprod);
       }
       $rulesClass->insere_log_prod_xml($arvprod, $message, $id, $codigo);
    }
}

function callWebServiceIncluirProduto($arqXml) {
    global $instanceManager;
    $rulesClass = $instanceManager->getService('\Controller\ErpController');
    
    $dadosAcesso = $rulesClass->getDadosAcesso();
    
    if(empty($dadosAcesso)) throw new \Exception("Dados de acesso não foram parametrizados.");
    
    $wsdl = $dadosAcesso["URL_CADASTRO"];
    $usuario = $dadosAcesso["USUARIO"];
    $senha = $dadosAcesso["SENHA"];
    
    $soapClient     = new SoapClient($wsdl);

    $xml = '<incluirProdutos>
               <usuario>'.$usuario.'</usuario>
               <senha>'.$senha.'</senha>
               <xmlProdutos>
                <![CDATA['.$arqXml.']]>
               </xmlProdutos>
            </incluirProdutos>';

           
    $xmlSimple = simplexml_load_string($xml);
    return $soapClient->__soapCall('incluirProdutos', array($xmlSimple)); 
}