<?php
namespace Controller;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;

class ErpController extends \Zeedhi\Framework\Controller\Simple {

    protected $erpController;
    
    public function __construct(\Service\ErpService $erpService) {
        $this->erpService = $erpService;
    }
	
    public function testConnection(){
		try {
			return $this->erpService->testConnection();
		}catch(\Exception $e){
			return $e->getMessage();
		}
	}
	
	public function getDadosAcesso() {
		try {
			return $this->erpService->getDadosAcesso();
		}catch(\Exception $e){
			return $e->getMessage();
		}
	}
	
	public function atualizaSysDadosAcesso($nrseqdadoac, $id_cenario, $cod_prod, $ponteiro_atualizacao) {
		try{
			return $this->erpService->atualizaSysDadosAcesso($nrseqdadoac, $id_cenario, $cod_prod, $ponteiro_atualizacao);
		}
		catch(\Exception $e){
			return $e->getMessage();
		}
	}
	
	public function buscaFilialProduto($cdexfilial){
		try {
			return $this->erpService->buscaFilialProduto($cdexfilial);
		}catch(\Exception $e){
			return $e->getMessage();
		}
	}
	
	public function geraLog($paramsLog){
		try {
			return $this->erpService->geraLog($paramsLog);
		}catch(\Exception $e){
			return $e->getMessage();
		}
	}
	
	public function updateProdutoExp($paramsProduto){
		try {
			return $this->erpService->updateProdutoExp($paramsProduto);
		}catch(\Exception $e){
			return $e->getMessage();
		}
	}
	
	public function updateFornecedorExp($paramsFornecedor){
		try {
			return $this->erpService->updateFornecedorExp($paramsFornecedor);
		}catch(\Exception $e){
			return $e->getMessage();
		}
	}
	
	public function updateClienteExp($paramsCliente){
		try {
			return $this->erpService->updateClienteExp($paramsCliente);
		}catch(\Exception $e){
			return $e->getMessage();
		}
	}
	
	public function updateNFEExp($paramsNFE){
		try {
			return $this->erpService->updateNFEExp($paramsNFE);
		}catch(\Exception $e){
			return $e->getMessage();
		}
	}
	
	public function updateEstoqueExp($paramsEstoque){
		try {
			return $this->erpService->updateEstoqueExp($paramsEstoque);
		}catch(\Exception $e){
			return $e->getMessage();
		}
	}
	
    public function callProcedurePROT_EXPORTA_FORNECEDOR(){
    	return $this->erpService->callProcedurePROT_EXPORTA_FORNECEDOR();
    }
    
    public function callProcedurePROT_EXPORTA_CLIENTE(){
    	return $this->erpService->callProcedurePROT_EXPORTA_CLIENTE();
    }
    
    public function callProcedurePROT_EXPORTA_NFENTRADA(){
    	return $this->erpService->callProcedurePROT_EXPORTA_NFENTRADA();
    }
    
    public function callProcedurePROT_EXPORTA_NFSAIDA(){
    	return $this->erpService->callProcedurePROT_EXPORTA_NFSAIDA();
    }
    
    public function callProcedureEXPORTA_PRODUTO_XML(){
    	return $this->erpService->callProcedureEXPORTA_PRODUTO_XML();
    }
    
    public function callProcedurePROT_EXPORTA_POS_ESTOQUE(){
    	return $this->erpService->callProcedurePROT_EXPORTA_POS_ESTOQUE();
    }
    
	public function retornaFornecedor(){
		return $this->erpService->retornaFornecedor();
	}
	
	public function retornaCliente(){
		return $this->erpService->retornaCliente();
	}

	public function retornaNFE(){
		return $this->erpService->retornaNFE();
	}
	
	public function retornaItensNFE($cdfilial, $nrlanctonf){
		return $this->erpService->retornaItensNFE($cdfilial, $nrlanctonf);
	}
	
	public function retornaNFS(){
		return $this->erpService->retornaNFS();
	}
	
	public function retornaItensNFS($cdfilial, $nrnota){
		return $this->erpService->retornaItensNFS($cdfilial, $nrnota);
	}
	
	public function retornaProduto(){
		return $this->erpService->retornaProduto();
	}

	public function UpdateProduto($cdarvprod){
		return $this->erpService->UpdateProduto($cdarvprod);
	}

	public function UpdateEnviaProdXml($cdarvprodini, $cdarvprodfin){
		return $this->erpService->UpdateEnviaProdXml($cdarvprodini, $cdarvprodfin);
	}
	
	public function insere_log_prod_xml($cdarvprod, $mensagem, $id, $codigo){
		return $this->erpService->insere_log_prod_xml($cdarvprod, $mensagem, $id, $codigo);
	}
	
	public function insere_imp_systax($imposto, $cenario, $cod_prod, $cst, $bc_compos, $aliquota, $p_red_bd, $vig_de, $vig_ate, $dispositivo, $observacao, $ori_prod, $infoAdic = '', $cenq = '', $paramsUfDest =  null){
		$nrseqimp = str_pad($this->erpService->getSequencialImp($imposto, $cenario, $cod_prod), 4, "0", STR_PAD_LEFT);

		return $this->erpService->insere_imp_systax($imposto, $cenario, $cod_prod, $cst, $nrseqimp, $bc_compos, $aliquota, $p_red_bd, $vig_de, $vig_ate, $dispositivo, $observacao, $infoAdic, $cenq, $paramsUfDest, $ori_prod);
	}
	
	public function insere_sys_material($id_cenario, $cod_prod, $descricao, $ean, $ncm, $ex_tipi, $ori_prod, $cfop, $cest){
		return $this->erpService->insere_sys_material($id_cenario, $cod_prod, $descricao, $ean, $ncm, $ex_tipi, $ori_prod, $cfop, $cest);
	}
	
	public function insere_sys_cenario($cenario, $dias_fut, $uf_origem, $uf_destino, $origem, $destinacao, $cod_natop, $mun_orig, $mun_dest, $cnae_dest, $ent_sai, $apelido){
		return $this->erpService->insere_sys_cenario($cenario, $dias_fut, $uf_origem, $uf_destino, $origem, $destinacao, $cod_natop, $mun_orig, $mun_dest, $cnae_dest, $ent_sai, $apelido);
	}

	public function retornaEstoque(){
		return $this->erpService->retornaEstoque();
	}
	
	public function retornaItensEstoque($nrlancestq, $cdfilial){
		return $this->erpService->retornaItensEstoque($nrlancestq, $cdfilial);
	}
	
	public function validaCallProcedure($operation){
		return $this->erpService->validaCallProcedure($operation);
	}
	
	public function insere_log_importa_regrafis($cenario, $cod_prod, $erro){
		return $this->erpService->insere_log_importa_regrafis($cenario, $cod_prod, $erro);
	}
	
	public function busca_sys_cenario($cenario) {
		return $this->erpService->busca_sys_cenario($cenario);
	}
	
	public function busca_produto($cenario, $prod, $ori_prod) {
		return $this->erpService->busca_produto($cenario, $prod, $ori_prod);
	}
	
	public function existeProduto($prod) {
		return $this->erpService->existeProduto($prod);
	}
	
	public function update_sys_material($idcenario, $cod_prod, $descr, $ean, $ncm, $ex_tipi, $ori_prod, $cfop, $cest) {
		return $this->erpService->update_sys_material($idcenario, $cod_prod, $descr, $ean, $ncm, $ex_tipi, $ori_prod, $cfop, $cest);
	}
	
	public function busca_icms($cenario, $prod, $cst, $vig_de, $vig_ate, $vig_de_UF_destino, $vig_ate_UF_destino, $uf_destino, $ori_prod) {
		$imposto = $this->erpService->busca_icms($cenario, $prod, $cst, $ori_prod);

	
		if($uf_destino){
			if($vig_de_UF_destino) {
				$vig_de_UF_destino = date('d/m/Y', strtotime($vig_de_UF_destino));
			}
			if($vig_ate_UF_destino) {
				$vig_ate_UF_destino = date('d/m/Y', strtotime($vig_ate_UF_destino));
			}
			if(!empty($imposto)) {
				foreach($imposto as $imp) {
					if(substr($imp["VIG_DE_UF_DEST"], 0, 10) == $vig_de_UF_destino && substr($imp["VIG_ATE_UF_DEST"], 0, 10) == $vig_ate_UF_destino) {
						return true;
					}
				}
			}

		}else{
			if($vig_de) {
				$vig_de = date('d/m/Y', strtotime($vig_de));
			}
			if($vig_ate) {
				$vig_ate = date('d/m/Y', strtotime($vig_ate));
			}
			
			if(!empty($imposto)) {
				foreach($imposto as $imp) {
					if(substr($imp["VIG_DE"], 0, 10) == $vig_de && substr($imp["VIG_ATE"], 0, 10) == $vig_ate) {
						return true;
					}
				}
			}
		}
	
		return false;
	}
	
	public function update_icms($imposto, $cenario, $cod_prod, $cst, $bc_compos, $aliquota, $p_red_bd, $vig_de, $vig_ate, $dispositivo, $observacao, $infoAdic, $paramsUfDest = null, $ori_prod){
		return $this->erpService->update_icms($imposto, $cenario, $cod_prod, $cst, $bc_compos, $aliquota, $p_red_bd, $vig_de, $vig_ate, $dispositivo, $observacao, $infoAdic, $paramsUfDest, $ori_prod);
	}
	
	public function busca_pis($cenario, $prod, $cst, $vig_de, $vig_ate, $ori_prod) {
		$imposto = $this->erpService->busca_pis($cenario, $prod, $cst, $ori_prod);
		if($vig_de) {
			$vig_de = date('d/m/Y', strtotime($vig_de));
		}
		if($vig_ate) {
			$vig_ate = date('d/m/Y', strtotime($vig_ate));
		}
		
		if(!empty($imposto)) {
			foreach($imposto as $imp) {
				if(substr($imp["VIG_DE"], 0, 10) == $vig_de && substr($imp["VIG_ATE"], 0, 10) == $vig_ate) {
					return true;
				}
			}
		}
		
		return false;
		
	}
	
	public function update_pis($imposto, $cenario, $cod_prod, $cst, $bc_compos, $aliquota, $p_red_bd, $vig_de, $vig_ate, $dispositivo, $observacao, $infoAdic, $ori_prod){
		return $this->erpService->update_pis($imposto, $cenario, $cod_prod, $cst, $bc_compos, $aliquota, $p_red_bd, $vig_de, $vig_ate, $dispositivo, $observacao, $infoAdic, $ori_prod);
	}

	public function busca_cofins($cenario, $prod, $cst, $vig_de, $vig_ate, $ori_prod) {
		$imposto = $this->erpService->busca_cofins($cenario, $prod, $cst, $ori_prod);
		if($vig_de) {
			$vig_de = date('d/m/Y', strtotime($vig_de));
		}
		if($vig_ate) {
			$vig_ate = date('d/m/Y', strtotime($vig_ate));
		}
		
		if(!empty($imposto)) {
			foreach($imposto as $imp) {
				if(substr($imp["VIG_DE"], 0, 10) == $vig_de && substr($imp["VIG_ATE"], 0, 10) == $vig_ate) {
					return true;
				}
			}
		}
		
		return false;
	}
	
	public function update_cofins($imposto, $cenario, $cod_prod, $cst, $bc_compos, $aliquota, $p_red_bd, $vig_de, $vig_ate, $dispositivo, $observacao, $infoAdic, $ori_prod){
		return $this->erpService->update_cofins($imposto, $cenario, $cod_prod, $cst, $bc_compos, $aliquota, $p_red_bd, $vig_de, $vig_ate, $dispositivo, $observacao, $infoAdic, $ori_prod);
	}
	
	public function busca_ipi($cenario, $prod, $cst, $vig_de, $vig_ate, $ori_prod) {
		$imposto = $this->erpService->busca_ipi($cenario, $prod, $cst, $ori_prod);
		if($vig_de) {
			$vig_de = date('d/m/Y', strtotime($vig_de));
		}
		if($vig_ate) {
			$vig_ate = date('d/m/Y', strtotime($vig_ate));
		}
			
		if(!empty($imposto)) {
			foreach($imposto as $imp) {
				if(substr($imp["VIG_DE"], 0, 10) == $vig_de && substr($imp["VIG_ATE"], 0, 10) == $vig_ate) {
					return true;
				}
			}
		}
		
		return false;
	}
	
	public function update_ipi($imposto, $cenario, $cod_prod, $cst, $bc_compos, $aliquota, $p_red_bd, $vig_de, $vig_ate, $dispositivo, $observacao,$infoAdic, $cenq, $ori_prod){
		return $this->erpService->update_ipi($imposto, $cenario, $cod_prod, $cst, $bc_compos, $aliquota, $p_red_bd, $vig_de, $vig_ate, $dispositivo, $observacao, $infoAdic,$cenq, $ori_prod);
	}
	
	public function busca_icmsst($cenario, $prod, $vig_de, $vig_ate, $ori_prod) {
		$imposto = $this->erpService->busca_icmsst($cenario, $prod, $ori_prod);
		if($vig_de) {
			$vig_de = date('d/m/Y', strtotime($vig_de));
		}
		if($vig_ate) {
			$vig_ate = date('d/m/Y', strtotime($vig_ate));
		}
		
		if(!empty($imposto)) {
			foreach($imposto as $imp) {

				if(substr($imp["VIG_DE"], 0, 10) == $vig_de && substr($imp["VIG_ATE"], 0, 10) == $vig_ate) {
					return true;
				}
			}
		}
		
		return false;
	}

	public function update_icmsst($imposto, $cenario, $cod_prod, $cst, $bc_compos, $aliquota, $p_red_bd, $vig_de, $vig_ate, $dispositivo, $observacao, $ori_prod){
		return $this->erpService->update_icmsst($imposto, $cenario, $cod_prod, '', $bc_compos, $aliquota, $p_red_bd, $vig_de, $vig_ate, $dispositivo, $observacao, $ori_prod);
	}
	
	/** 
	 * METODOS TRATAMENTO DE XML
	 */
	
	public function buildXml($data, $method){
		// coloca no formato XML
		return $this->arrayToXml($data, $method);
	}
	
	public function buildXml2($data, $method){
		// coloca no formato XML
		return $this->arrayToXml2($data, $method);
	}
	
	public function buildXml3($data, $method){
		// coloca no formato XML
		return $this->arrayToXml3($data, $method);
	}
	
	public function arrayToXml($data, $elementName) {
		$result = '';
	    foreach($data as $key => $value) {
	        if (is_array($value)) {
	        	if(is_numeric($key)){
	        		$result .= $this->arrayToXml($value, 'ITEMNFE');
	        	}else{
	        		$result .= $this->arrayToXml($value, $key);
	        	}
	        } else {
	        	$result .= '<'.$key.'>'.  htmlspecialchars("$value") . '</'.$key.'>';
	        }
	    }
	    if ($elementName) {
	     	return '<'.$elementName.'>'.  $result. '</'.$elementName.'>';
	    } else {
	    	return $result;
	    }
	}
	
	public function arrayToXml2($data, $elementName) {
		$result = '';
	    foreach($data as $key => $value) {
	        if (is_array($value)) {
	        	if(is_numeric($key)){
	        		$result .= $this->arrayToXml2($value, 'ITEMPV');
	        	}else{
	        		$result .= $this->arrayToXml2($value, $key);
	        	}
	        } else {
	        	$result .= '<'.$key.'>'.  htmlspecialchars("$value") . '</'.$key.'>';
	        }
	    }
	    if ($elementName) {
	     	return '<'.$elementName.'>'.  $result. '</'.$elementName.'>';
	    } else {
	    	return $result;
	    }
	}
	
	public function arrayToXml3($data, $elementName) {
		$result = '';
	    foreach($data as $key => $value) {
	        if (is_array($value)) {
	        	if(is_numeric($key)){
	        		$result .= $this->arrayToXml3($value, 'ITEMMOV');
	        	}else{
	        		$result .= $this->arrayToXml3($value, $key);
	        	}
	        } else {
	        	$result .= '<'.$key.'>'.  htmlspecialchars("$value") . '</'.$key.'>';
	        }
	    }
	    if ($elementName) {
	     	return '<'.$elementName.'>'.  $result. '</'.$elementName.'>';
	    } else {
	    	return $result;
	    }
	}
}